/*
 * 3D Morph Toolkit
 *
 * (c) 2000 Sylvain Tertois
 *
 *
 * MTMatrix: class that make 3D linear transformations easier
**/

#ifndef MTMATRIX_H
#define MTMATRIX_H

class MTPoints;

class MTMatrix
{
public:
// creates an identity matrix (no transformation)
	MTMatrix();
// constructor with all the values
	MTMatrix(float,float,float,float,float,float,float,float,float,float,float,float);

	MTMatrix &operator=(const MTMatrix&);
	MTMatrix &operator*=(const MTMatrix&);
	MTMatrix operator*(const MTMatrix&) const;

// basic matrices	
/// scale
	static MTMatrix Scale(float scale);
	static MTMatrix Scale(float x,float y,float z);

/// translation
	static MTMatrix Translate(float x,float y,float z);
	
/// rotation
	static MTMatrix RotateX(float alpha);
	static MTMatrix RotateY(float alpha);
	static MTMatrix RotateZ(float alpha);
	
// access to the values
	inline const float &ElemConst(unsigned int i,unsigned int j) const { return (matrix[i*3+j]); }
	inline float &Elem(unsigned int i,unsigned int j) { return (matrix[i*3+j]); }

private:
	float matrix[12];
};


#endif //MTMATRIX_H
