/*
 * 3D Morph Toolkit
 *
 *  by Sylvain Tertois
 *
 * MTObject class, used in add-ons
 *
**/

#ifndef MTOBJECT_H
#define MTOBJECT_H

class MTPoints;
class BView;

#include <Invoker.h>

class MTObject
{
public:
	MTObject();
	virtual ~MTObject();
	
	// functions
	inline void RequestUpdate()	// request an update of the image shown	
								// in the view window
	{ m_UpdateInvoker.Invoke(); }
	
	// overridable functions
	virtual MTPoints *Update(float);	
			// generate a new set of points. Ignore the float for now. It will
			// be useful later
			// the MTPoints object becomes the responsability of the application
			// the add-on musn't use or delete it after this call
			// mustn't return NULL
	virtual BView *CreateView();
			// creates a view to configure the add-on
			// returns NULL if no configuration
	
	BInvoker m_UpdateInvoker;
			// Invoker used to request an update
};

#endif //MTOBJECT_H